import java.awt.*;
import java.applet.*;
//we have to import the image package!
import java.awt.image.*;

//a flicker free animation with animation phases!

public class Project12 extends Applet implements Runnable 
{
	Thread runner;
	private Image Buffer;
   private Graphics gBuffer;
   int x, ticker=0, frame=0;
   boolean moveRight=true;

   Image background, starStrip, star[];	
		
	//Init is called first, do any initialisation here	
	public void init() 
	{	
		//create graphics buffer, the size of the applet
		Buffer=createImage(size().width,size().height);
      gBuffer=Buffer.getGraphics();					
      
      background=loadImage("wood.jpg");
      starStrip=loadImage("stars.gif");
      
      star = new Image[5];
	  	extractImages(starStrip,star,5,130,120);
	}
	
	public void extractImages(Image imagestrip, Image images[],int num,int width, int height)
	{
	  	ImageProducer source = imagestrip.getSource();
		  
	  	for(int i=0; i<num; i++)
		  	{
		  		ImageFilter extractFilter=new CropImageFilter(0,i*height,width,height);
		  		ImageProducer producer = new FilteredImageSource(source,extractFilter);
		  		images[i] = createImage(producer);
	  		}
  }
  
  public Image loadImage(String imagename)
  {
			Image image=getImage(getDocumentBase(),imagename);
			MediaTracker tracker=new MediaTracker(this);
			tracker.addImage(image,0);
			try
			{
				tracker.waitForID(0);
			}
			catch(InterruptedException e){}
			
			return image;
	} 	

	public void start()
	{
			if (runner == null) 
			{
					runner = new Thread (this);
            	runner.start();
        	}
   }

   public void stop()
	{
        if (runner != null) 
			{
            	runner.stop();
            	runner = null;
        	}
   }

	public void run()
	{
		while(true) 
		{
				//Thread sleeps for 15 milliseconds here					
				try {runner.sleep(15);}
            catch (Exception e) { }
			
				//here we draw the wood background
				gBuffer.drawImage(background,0,0,this);				
			
				if(moveRight==true)
				{
					if(x<size().width-130)				
						x+=2;
					else
						moveRight=false;
				}				
				
				if(moveRight==false)
				{
					if(x>0)				
						x-=2;
					else
						moveRight=true;
				}

				ticker++;
				
				//this sets the animation phases
				//you can determine the speed of the phases change here
				if(ticker>2)
					{
						if(frame<4)
							frame++;
						else
							frame=0;
							
						ticker=0;							
					}				
				
				//draws the star animation
				gBuffer.drawImage(star[frame],x,80,this);
			
            repaint();	                        
		}	
	}
	
	//is needed to avoid erasing the background by Java
	public void update(Graphics g)
	{
		paint(g);
   }
        
   public void paint(Graphics g) 
	{
		g.drawImage (Buffer,0,0, this);				
   }	
}

