import java.awt.*;
import java.applet.*;
//we need to import the util package for the time functions
import java.util.*;

public class Project19 extends Applet implements Runnable
{
		Thread runner;
		Image Buffer;
      Graphics gBuffer;
      Color bgColor, fgColor;
      int fontSize;
		int format24;
      
      public void init()
      {		
      		//create off-screen image we can draw to	
      		Buffer=createImage(size().width,size().height);
            gBuffer=Buffer.getGraphics();	
            
            //Interprete the parameters from the HTML page

				//read the fontSize parameter
            String clockSizeStr=getParameter("font_size");
            //we have to convert the String to an integer, base is 10 (decimal)
            fontSize=Integer.parseInt(clockSizeStr, 10);
            
            format24=Integer.parseInt(getParameter("format24"), 10);

				String redStr, greenStr, blueStr;
				int redInt, greenInt, blueInt;
								
				//read the background color parameter
				String bgColorStr=getParameter("bg_color");
				redStr=bgColorStr.substring(0,2);
				greenStr=bgColorStr.substring(2,4);
				blueStr=bgColorStr.substring(4);

				//during conversion, we convert from hexadecimal (base 16)!
				redInt=Integer.parseInt(redStr, 16);
				greenInt=Integer.parseInt(greenStr, 16);
				blueInt=Integer.parseInt(blueStr, 16);

				bgColor=(new Color(redInt, greenInt, blueInt));
				
				//read the foreground color parameter
				String fgColorStr=getParameter("fg_color");
				redStr=fgColorStr.substring(0,2);
				greenStr=fgColorStr.substring(2,4);
				blueStr=fgColorStr.substring(4);

				redInt=Integer.parseInt(redStr, 16);
				greenInt=Integer.parseInt(greenStr, 16);
				blueInt=Integer.parseInt(blueStr, 16);

				fgColor=(new Color(redInt, greenInt, blueInt));			
      }		
		
		public void start()
		{
			if (runner == null) 
			{
				runner = new Thread (this);
            runner.start();
        	}
    	}
	    
	   public void stop()
		{
      	if (runner != null) 
			{
            	runner.stop();
            	runner = null;
      	}
    	}
	    
	   public void run()
		{
			while(true) 
			{				
				//halt the thread for 100 ms here	
				try {runner.sleep(100);}
            	catch (Exception e) { }			
			
            	repaint();	                        
			}	
		}
		
	public void update(Graphics g)
	{
		paint(g);
		}		

	public void paint (Graphics g)
	{		
		//create a new time object		
				Date today=new Date();
				
				//get the seconds, minutes and hours
		int sec=today.getSeconds();
				int min=today.getMinutes();
				int hour=today.getHours();
				
				String secStr, minStr, hourStr;
				
				//copy the time integers to our string objects
				//if values are less than 10 we add a 0
				
				//12 hour US time format with AM and PM
				boolean am;
				
				if(hour<12)
					am=true;
				else
					am=false;					
					
				if(format24==0&&hour>12)
					hour-=12;
				
				if(hour<10)
					hourStr="0"+hour;			
				else
					hourStr=""+hour;

				if(min<10)
					minStr="0"+min;			
				else
					minStr=""+min;

				if(sec<10)
					secStr="0"+sec;			
				else
					secStr=""+sec;

				//repaint the background in the background color
				gBuffer.setColor(bgColor);
		gBuffer.fillRect(0,0,size().width,size().height);
				
				String outputString=hourStr+":"+minStr+":"+secStr;
				
				if(format24==0)
				{
						if(am==true)
							outputString+=" AM";
						else
							outputString+=" PM";
				}
				
				Font clockFont=new Font("Helvetica", Font.BOLD, fontSize);
				
				//measure the size of the string to center it
				FontMetrics fm = gBuffer.getFontMetrics(clockFont);		
				int stringWidth=fm.stringWidth(outputString);
				int stringHeight=gBuffer.getFontMetrics().getHeight();
			
				//set the font and the foreground color
				gBuffer.setFont(clockFont);
				gBuffer.setColor(fgColor);			
				
				//center the string inside the applet
		gBuffer.drawString(outputString,
			 (size().width-stringWidth)/2, (size().height+stringHeight/2)/2);
		
		//copy the buffer to the screen (no flicker!)
		g.drawImage (Buffer,0,0, this);			
	}
}


