import java.awt.*;
import java.applet.*;

//growing bubbles applet with a separate bubble class!

class GrowingBubble
{
	//instance variables
	int x, y, diameter, startDiameter, endDiameter;		
	Color randomColor;
	Graphics g;
	
	//constructor
	public GrowingBubble()
	{				
		int red=(int)(Math.random()*255);
		int green=(int)(Math.random()*255);
		int blue=(int)(Math.random()*255);
	
		//each bubble object has one random color	
		randomColor=new Color(red, green, blue);	
		
		//start diameter between 10 and 30
		startDiameter=(int)(Math.random()*20)+10;		
		
		//end diameter between 50 and 150
		endDiameter=(int)(Math.random()*100)+50;	
		
		diameter=startDiameter;					
	}
	
	public void setPosition(int x, int y)
	{
		this.x=x;
		this.y=y;								
	}
	
	public void drawBubble()
	{					
		g.setColor(randomColor);
		g.fillOval(x-diameter/2,y-diameter/2,diameter,diameter);		
	}	
	
	public void grow()
	{	
		//quickly grow, till end diameter is reached	
		if(diameter<endDiameter)
			diameter+=4;			
	}
	
	public void paint(Graphics gr)
	{	
		g=gr;
		
		drawBubble();
	}
}

public class Project24 extends Applet implements Runnable
{	
	Image Buffer;
   Graphics gBuffer;		
   GrowingBubble myBubble;
   Thread runner;
   boolean clicked;
	
	public void init() 
	{			
		Buffer=createImage(size().width,size().height);
      gBuffer=Buffer.getGraphics();	      				
	}
	
	public void start()
	{
		if (runner == null) 
		{
			runner = new Thread (this);
         runner.start();
     	}
   }
	    
	public void stop()
	{
     	if (runner != null) 
		{
        	runner.stop();
        	runner = null;
     	}
   }
	    
	public void run()
	{
		while(true) 
		{				
			//halt the thread for 15 ms here	
			try {runner.sleep(15);}
           	catch (Exception e) { }	
	          
	         //bubble methods may only be accessed, if we have
	         //created the object in the mouseDown method!  
	         if(clicked)
	         {
	         	myBubble.grow();
	         	myBubble.paint(gBuffer);		
		      }
			
           	repaint();	                        
		}	
	} 	
	   
	public boolean mouseDown(Event evt,int x,int y)
	{		
		myBubble = new GrowingBubble();
		
		myBubble.setPosition(x,y);						

		clicked=true;		
		
		return true;
	}	
		
	public void update(Graphics g)
	{
		paint(g);
   }
        
   public void paint(Graphics g) 
	{	
		gBuffer.setColor(Color.black);
		gBuffer.drawString("Click the applet to paint growing bubbles!", 30,20);		
		
		g.drawImage (Buffer,0,0, this);				
   }	
}


