import java.awt.*;
import java.applet.*;

class BreathingBubble
{
	//instance variables
	int x, y, diameter, startDiameter, endDiameter;		
	boolean growing=true;
	Color randomColor;
	Graphics g;
	
	//constructor
	public BreathingBubble()
	{				
		int red=(int)(Math.random()*255);
		int green=(int)(Math.random()*255);
		int blue=(int)(Math.random()*255);
	
		//each bubble object has one random color	
		randomColor=new Color(red, green, blue);	
		
		//start diameter between 10 and 30
		startDiameter=(int)(Math.random()*20)+10;		
		
		//end diameter between 50 and 150
		endDiameter=(int)(Math.random()*100)+50;	
		
		diameter=startDiameter;
	}
	
	public void setPosition(int x, int y)
	{
		this.x=x;
		this.y=y;								
	}
	
	public void drawBubble()
	{			
		g.setColor(randomColor);
		g.fillOval(x-diameter/2,y-diameter/2,diameter,diameter);		
	}	
	
	public void breathe()
	{			
		//grow till end diameter is reached	
		if(growing)
		{
			if(diameter<endDiameter)
				diameter++;	
			else
				growing=false;
		}
		//shrink till start diameter is reached
		else
		{
			if(diameter>startDiameter)
				diameter--;	
			else
				growing=true;
		}			
	}
	
	public void paint(Graphics gr)
	{	
		g=gr;
		drawBubble();		
	}
}

public class Project25 extends Applet implements Runnable
{	
	Image Buffer;
   Graphics gBuffer;		
   BreathingBubble myBubble[];
   Thread runner;
   boolean clicked;
  	int index;
	int MAX=100;
	
	public void init() 
	{			
		Buffer=createImage(size().width,size().height);
      gBuffer=Buffer.getGraphics();	 
      myBubble = new BreathingBubble[MAX];     				
	}
	
	public void start()
	{
		if (runner == null) 
		{
			runner = new Thread (this);
         runner.start();
     	}
   }
	    
	public void stop()
	{
     	if (runner != null) 
		{
        	runner.stop();
        	runner = null;
     	}
   }
	    
	public void run()
	{
		Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

		while(true) 
		{		
			try {runner.sleep(15);}
           	catch (Exception e) { }	
	          
	         //bubble methods may only be accessed, if we have
	         //created the object in the mouseDown method!  
	         if(clicked)
	         {
	         	for(int i=0;i<index;i++)
		         {
		         	myBubble[i].breathe();
			         myBubble[i].paint(gBuffer);			
		         }
		      }							
           	repaint();	                      
		}	
	} 	
	   
	public boolean mouseDown(Event evt,int x,int y)
	{					
		if(index<MAX)
		{
			myBubble[index] = new BreathingBubble();
			
			myBubble[index].setPosition(x,y);
			
			index++;					
		}

		clicked=true;
		
		return true;
	}	
		
	public void update(Graphics g)
	{
		paint(g);
   }
        
   public void paint(Graphics g) 
	{			
		gBuffer.setColor(Color.black);
		gBuffer.drawString("Click the applet to paint breathing bubbles!", 20,20);		
				
		g.drawImage (Buffer,0,0, this);				
		
		//paint the background white (must be done last!)
		gBuffer.setColor(Color.white);
		gBuffer.fillRect(0,0,size().width,size().height);
   }	
}



